// -Test Map.cpp-
// Generates a test map for the tile engine demo
// Written by J. Farrell

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

int main(int argc, char* argv[])
{
	int x, y, z;

	// generate a random map -- this should be replaced by a nice
	// map editor when you get a chance :)
	BYTE byMap[60][60][2];

	// first set everything to grass
	for (x=0; x<60; x++)
	{
		for (y=0; y<60; y++)
		{
			byMap[x][y][0] = 1;
			byMap[x][y][1] = 0;
		}
	}

	// now add a lake somewhere
	srand(GetTickCount());
	int nWidth = 5 + rand()%10;
	int nHeight = 5 + rand()%10;
	int xPos = 1 + rand()%(57 - nWidth);
	int yPos = 1 + rand()%(57 - nHeight);
	for (x=xPos; x<(xPos + nWidth); x++)
	{
		for (y=yPos; y<(yPos + nHeight); y++)
		{
			byMap[x][y][0] = 4;
		}

		// add the horizontal coastline
		byMap[x][yPos-1][0] = 8;
		byMap[x][yPos + nHeight][0] = 9;
	}

	// add the vertical coastline
	for (y=yPos; y<(yPos + nHeight); y++)
	{
		byMap[xPos-1][y][0] = 11;
		byMap[xPos + nWidth][y][0] = 10;
	}

	// add random trees
	for (z=0; z<500; z++)
	{
		x = rand()%60;
		y = rand()%60;

		if ((byMap[x][y][0] == 1) ||
			(byMap[x][y][0] == 9))
		{
			byMap[x][y][0] = 3;
			if (y > 0)
				byMap[x][y-1][1] = 2;
		}
	}

	// write map to file
	FILE *pfile = fopen("testmap.dat", "wb");
	putc(59, pfile);
	putc(59, pfile);
	for (x=0; x<60; x++)
	{
		for (y=0; y<60; y++)
		{
			putc(byMap[x][y][0], pfile);
			putc(byMap[x][y][1], pfile);
		}
	}
	fclose(pfile);

	return 0;
}

