// -Tile Engine Demo-
// Main header file
// Written by J. Farrell

#ifndef INCLUDE_ME_ONLY_ONCE_OR_DIE

#define INCLUDE_ME_ONLY_ONCE_OR_DIE
#define WIN32_LEAN_AND_MEAN

// INCLUDES
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>
#include <stdio.h>

// DATA TYPES
typedef struct TILE_type
{
    RECT rcLocation;    // location on DirectDraw surface
    int bWalkOK;        // can the tile be walked on?
    int nAnimSpeed;     // animation speed in frames
    DWORD dwFlags;      // approach flags
    TILE_type *lpNext;  // next tile in animation
	UINT uiFrames;      // frame counter
} TILE, FAR* LPTILE;

// Since we're not dealing with NPCs or scripts just yet, I've
// commented those fields out of the map data structure.

typedef struct MAPDATA_type
{
    int xMax, yMax;              // map size in tiles
    int xCamera, yCamera;        // camera location in pixels
    int xMaxCamera, yMaxCamera;  // max camera coordinates
    //int nNPCCount;               // number of NPCs
    //int nScriptCount;            // number of linked scripts
    //LPNPC lpnpc;                 // linked NPCs
    //LPSCRIPT lpscr;              // linked scripts
} MAPDATA, FAR* LPMAPDATA;

// CONSTANTS
#define NUM_TILES        12
#define TILESET_WIDTH    32
#define TILESET_HEIGHT  384

// MACROS
#define INIT_DXSTRUCT(dxstruct) { ZeroMemory(&dxstruct, sizeof(dxstruct)); dxstruct.dwSize = sizeof(dxstruct); }
#define KEYSTATE(key) ((GetAsyncKeyState(key) & 0x8000) ? TRUE : FALSE)

// PROTOTYPES
LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
int Init_Map(void);
int Initialize(void);
int Load_Bitmap(char *lpszName, int x, int y, LPDIRECTDRAWSURFACE7 lpdds);
void Render_Map(void);
void Shutdown(void);

#endif